"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchedulableTask = void 0;
const Worker_1 = require("./Worker");
class SchedulableTask {
    constructor() {
        this.id = Date.now();
        this.queue = 'default';
        this.tries = 0;
        this.storageKey = this.constructor.name;
    }
    dispatch() {
        return __awaiter(this, void 0, void 0, function* () {
            yield Worker_1.Worker.addTask(this);
        });
    }
    serialize() {
        return JSON.stringify(this);
    }
    static decorate(jsonObject) {
        let obj = new this;
        for (let prop in jsonObject) {
            obj[prop] = jsonObject[prop];
        }
        return obj;
    }
}
exports.SchedulableTask = SchedulableTask;
//# sourceMappingURL=SchedulableTask.js.map